void relay_tty(struct connection_state *cs)
{
  fd_set readfds ;
  int done, maxfd, buflen, status, i, r ;
  char buf[8192] ;
  struct timeval timeout ;
  int trigger=0 ;

  fprintf(stderr,"relaying for tty\n") ;
  maxfd=cs->ttp_to_interface[0] ;
  for(done=0;!done;)
    {
      FD_ZERO(&readfds) ;
      FD_SET(0,&readfds) ;
      FD_SET(cs->ttp_to_interface[0],&readfds) ;
      timeout.tv_sec=32 ;
      timeout.tv_usec=0 ;
      r=select(maxfd+1,&readfds,NULL,NULL,&timeout) ;

      if(FD_ISSET(0,&readfds))
	if((buflen=read(0,buf,8192))>0)
	  {
	    sure_write(NULL,cs->interface_to_ttp[1],buf,buflen,0) ;
	    /* fprintf(stderr,"ttp_tty: relay %d bytes from tty to ttp\n",buflen) ; */
	  }

      if(FD_ISSET(cs->ttp_to_interface[0],&readfds))
	if((buflen=read(cs->ttp_to_interface[0],buf,8192))>0)
	  {
	    /*
	      fprintf(stderr,"ttp_tty: relay %d bytes from ttp to tty\n",buflen) ;
	      for(i=0;i<buflen;i++)
	      fprintf(stderr,"  [%d] = 0x%x\n",i,buf[i]) ;
	    */
	    sure_write(NULL,1,buf,buflen,0) ;
	  }
    }
}

void init_tty(struct connection_state *cs)
{
  pipe(cs->ttp_to_interface) ;
  pipe(cs->interface_to_ttp) ;

  cs->active=1 ;
  cs->pid=fork() ;
  if(!cs->pid)
    {
      relay_tty(cs) ;
      exit(0) ;
    }
  fprintf(stderr,"tty interface spawned with pid %d\n",cs->pid) ;
}
